﻿%%FRAGMENTINPUT_STRUCT%%

%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

%%SAMPLERBACK_BINDING%% var samplerBack : sampler;
%%TEXTUREBACK_BINDING%% var textureBack : texture_2d<f32>;


struct ShaderParams {
	threshold : f32,
	lowThreshold : f32,
	brightness : f32,
	tint : vec3<f32>,
	maskedOpacity : f32
};


%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%C3PARAMS_STRUCT%%

%%C3_UTILITY_FUNCTIONS%%


@fragment
fn main(input : FragmentInput) -> FragmentOutput
{	
	let n: vec2<f32> = c3_getBackUV(input.fragPos.xy, textureBack);
	let back = textureSample(textureBack, samplerBack, n);
	let front = textureSample(textureFront, samplerFront, input.fragUV);
	
	let mask: f32 = smoothstep(shaderParams.threshold - shaderParams.lowThreshold, shaderParams.threshold, dot(back.rgb, vec3<f32>(0.2126, 0.7152, 0.0722)));

	var color: vec4<f32> = (back + shaderParams.brightness - 1.) * mask * front.a;

	color = color * (vec4<f32>(shaderParams.tint, 1.));
	
	var output: FragmentOutput;
	output.color = vec4<f32>(color.rgb, color.a + shaderParams.maskedOpacity * front.a);;
	return output;
}